dmultinom <- function(x, size, prob, log = FALSE)
{
	k <- nrow(x)
	n <- ncol(x)

	fj <- matrix(NA, n, k)
	for (j in 1:k) {
		fj[,j] <- -lgamma(x[j,]+1) + x[j,] * log(prob[j])
	}

	log.ff <- lgamma(m+1) + rowSums(fj)
	if (log) return(log.ff)
	else return(exp(log.ff))
}
