r.multmix <- function(n, P, Pi, m)
{
	J <- length(Pi)
	k <- nrow(P)
	z <- sample(1:J, prob = Pi, replace = TRUE, size = n)
	
	if (length(m) == 1) m <- rep(m,n)
	y <- matrix(NA, nrow = k, ncol = n)

	for (i in 1:n) {
		y[,i] <- rmultinom(1, prob = P[,z[i]], size = m[i])
	}

	return(y)
}

d.multmix <- function(x, P, Pi, m, log = FALSE)
{
	Pi <- normalize(Pi)
	J <- length(Pi)
	n <- ncol(x)
	
	ff <- matrix(NA, n, J)
	for(j in 1:J) {
		ff[,j] <- dmultinom(x, m, P[,j])
	}
	
	res <- as.numeric(ff %*% Pi)
	if (log) return(log(res))
	else return(res)
}
