source("fit-mle.R")

fit.normal.x.mle <- function(y, X, extra.tx)
{
	Data <- list(y = y, X = X, n = length(y))
	d <- ncol(X)
	qq <- d + 1
	
	phi.init <- rep(0, qq)
	
	theta.tx <- function(phi) { list(Beta = phi[1:d], sigma = exp(phi[d+1])) }
	
	loglik <- function(phi, Data)
	{
		theta <- theta.tx(phi)
		mu <- Data$X %*% theta$Beta
		sum( dnorm(Data$y, mean = mu, sd = theta$sigma, log = TRUE) )
	}
	
	fit.out <- fit.mle(phi.init, loglik, theta.tx, extra.tx, Data)
	
	fit.out$description <- paste0(
		"y[i] ~indep~ N(mu[i], sigma^2)\n",
		"mu[i] = x[i]^T Beta")
	return(fit.out)
}
