source("rcb.R")
source("fit-mle.R")

fit.rcb.mle <- function(y, m, extra.tx)
{
	Data <- list(y = y, m = m, n = length(y))
	qq <- 2
	phi.init <- rep(0, qq)
	
	theta.tx <- function(phi)
	{
		list(Pi = plogis(phi[1]), rho = plogis(phi[2]))
	}
	
	loglik <- function(phi, Data)
	{
		theta <- theta.tx(phi)
		sum( d.rcb(Data$y, Pi = theta$Pi, rho = theta$rho,
			m = Data$m, log = TRUE) )
	}

	fit.out <- fit.mle(phi.init, loglik, theta.tx, extra.tx, Data)
	fit.out$description <- "y[i] ~iid~ RCB(Pi, rho)"
	return(fit.out)
}

