fit.nr <- function(theta.init, loglik, score = NULL, hess = NULL,
	Data, max.iter = Inf, tol = 1e-6)
{
	ll <- -Inf
	iter <- 0
	delta <- Inf
	theta <- theta.init

	if (is.null(score)) {
		score <- function(theta, Data) { grad(func = loglik, x = theta, Data = Data,
			method.args = list(d = 1e-4)) }
	}

	if (is.null(hess)) {
		hess <- function(theta, Data) { hessian(func = loglik, x = theta, Data = Data,
			method.args = list(d = 1e-4)) }
	}

	while (iter < max.iter && abs(delta) > tol) {
		iter <- iter + 1
		S <- score(theta, Data)
		H <- hess(theta, Data)
		theta <- theta - solve(H, S)

		ll.old <- ll
		ll <- loglik(theta, Data)
		delta <- ll - ll.old
	}

	list(loglik = ll, iter = iter, tol = delta, converged = (iter < max.iter), theta.hat = theta)
}
