fit.fs <- function(theta.init, loglik, score, fim, Data, max.iter = Inf,
	tol = 1e-6)
{
	hess <- function(theta, Data) { -fim(theta, Data) }
	fit.nr(theta.init, loglik, score, hess, Data, max.iter, tol)
}

fit.afs <- function(theta.init, loglik, score, afim, Data, max.iter = Inf,
	tol = 1e-6)
{
	hess <- function(theta, Data) { -afim(theta, Data) }
	fit.nr(theta.init, loglik, score, hess, Data, max.iter, tol)
}

fit.fs.hybrid <- function(theta.init, loglik, score, fim, afim, Data,
	max.iter = Inf, tol = 1e-6, warmup.tol = 1e-4)
{
	out.afs <- fit.afs(theta.init, loglik, score, afim, Data, max.iter, tol = warmup.tol)
	fit.fs(out.afs$theta.hat, loglik, score, fim, Data, max.iter - out.afs$iter, tol)
}

fit.nr.hybrid <- function(theta.init, loglik, score, hess, afim, Data,
	max.iter = Inf, tol = 1e-6, warmup.tol = 1e-4)
{
	out.afs <- fit.afs(theta.init, loglik, score, afim, Data, max.iter, tol = warmup.tol)
	fit.nr(out.afs$theta.hat, loglik, score, hess, Data, max.iter - out.afs$iter, tol)
}
