gof.binomial <- function(y, m, f, gof.breaks, qq)
{
	if (length(m) == 1) m <- rep(m, length(y))
	K <- length(gof.breaks) - 1
	Ob <- gof.binomial.obs(y, m, gof.breaks)
	Ex <- numeric(K)
	n <- length(y)

	gof.breaks[-c(1,K+1)] <- gof.breaks[-c(1,K+1)] + .Machine$double.eps
	
	for (i in 1:n)
	{
		tt <- seq(0, m[i])
		ff <- f(tt, i)
		Int <- findInterval(x = tt / m[i], vec = gof.breaks, rightmost.closed = TRUE)
		res <- aggregate(ff ~ Int, FUN = sum)
		Ex[res$Int] <- Ex[res$Int] + res$ff
	}

	tab <- cbind(Ob, Ex)
	X <- sum( (Ob - Ex)^2 / Ex )
	df.low <- K - 1 - qq
	df.high <- K - 1
	pvalue.low <- 1 - pchisq(X, df.low)
	pvalue.high <- 1 - pchisq(X, df.high)
		
	brak <- c("[", rep("(", K-1))
	labels <- sprintf("%s%0.04f,%0.04f]", brak, gof.breaks[-(K+1)], gof.breaks[-1])
	rownames(tab) <- labels 
		
	res <- list(tab = tab, X = X, df.low = df.low, df.high = df.high,
		pvalue.low = pvalue.low, pvalue.high = pvalue.high, f = f,
		breaks = gof.breaks, m = m)
	class(res) <- "gof.binomial"
	return(res)
}
